import { useState } from "react";
import { Entity, PointGraphics, useCesium } from "resium";
import { useInterval } from "ahooks";

// 从拉布拉多海到青藏高原
const dataLabToQTP = [
  { longitude: -62, latitude: 69, height: 1000000, time: 10 },
  { longitude: -20, latitude: 55, height: 1000000, time: 20 },
  { longitude: 29, latitude: 49, height: 1000000, time: 30 },
  { longitude: 62, latitude: 45, height: 1000000, time: 40 },
  { longitude: 98, latitude: 48, height: 1000000, time: 50 },
];

function Point() {
  const { viewer } = useCesium();
  const [delay, setDelay] = useState(1000);

  const start = viewer.clock.startTime;
  const stop = viewer.clock.stopTime;

  const pathMaterial = new Cesium.PolylineDashMaterialProperty({
    dashLength: 20,
    color: new Cesium.Color(4 / 255, 251 / 255, 253 / 255),
  });

  useInterval(() => {
    if (viewer.clock?.shouldAnimate) setDelay(undefined);
  }, delay);

  /**
   * 计算飞行路径
   * 数据坐标
   * {SampledPositionProperty|*}
   */
  function createProperty(source) {
    let property = new Cesium.SampledPositionProperty();
    for (let i = 0; i < source.length; i++) {
      let time = Cesium.JulianDate.addSeconds(
        start,
        source[i].time,
        new Cesium.JulianDate()
      );
      let position = Cesium.Cartesian3.fromDegrees(
        source[i].longitude,
        source[i].latitude,
        source[i].height
      );
      // 添加位置，和时间对应
      property.addSample(time, position);
    }
    property.setInterpolationOptions({
      interpolationDegree: 10,
      interpolationAlgorithm: Cesium.LagrangePolynomialApproximation,
    });

    return property;
  }

  const property = createProperty(dataLabToQTP);

  return (
    <Entity
      id={"point"}
      position={property}
      availability={
        new Cesium.TimeIntervalCollection([
          new Cesium.TimeInterval({
            start: start,
            stop: stop,
          }),
        ])
      }
      orientation={new Cesium.VelocityOrientationProperty(property)}
      path={{
        resolution: 1,
        material: pathMaterial,
        // leadTime、trailTime 不设置 path全显示
        leadTime: 0, // 设置为0时 模型通过后显示path
        // trailTime: 0, // 设置为0时 模型通过后隐藏path
        width: 2,
      }}
    >
      <PointGraphics
        show={true}
        color={Cesium.Color.SKYBLUE}
        pixelSize={10}
        outlineColor={Cesium.Color.YELLOW}
        outlineWidth={3}
      />
    </Entity>
  );
}

export default Point;
